
import gcoord from "gcoord";
import { wgs_gcj_encrypts } from "@/utils/LonLatConvert.js"
export const openMap = (parmas = {}) => {
	const { longitude, latitude, name, mapApp } = parmas;
	var geojson = {
	  "type": "Point",
	  "coordinates": [longitude, latitude]
	}
	let result = gcoord.transform(geojson,gcoord.WGS84,gcoord.GCJ02);
	// console.log(result , wgs_gcj_encrypts({lng:longitude,lat:latitude})); 
	// console.log('wgs84Togcj02 = ' , longitude, latitude ,wgs84Togcj02(longitude, latitude))
 
	let url;
	switch (mapApp) {
		case 'baidu':
			url =
				`baidumap://map/marker?location=${latitude},${longitude}&title=${encodeURIComponent(name)}&content=${encodeURIComponent(name)}&src=webapp`;
			break;
		case 'gaode': 
		const {lng ,lat} = wgs_gcj_encrypts({lng:longitude,lat:latitude})
			url =
				`iosamap://navi?sourceApplication=webapp&backScheme=myapp://&lat=${lat}&lon=${lng}&name=${encodeURIComponent(name)}&dev=0`;
			break;
		case 'tencent':
			url =
				`qqmap://map/rgeo?location=${latitude},${longitude}&name=${encodeURIComponent(name)}&coord_type=1&policy=0`;
			break;
		default:
			console.error('不支持的地图类型');
			return;
	}

	// 使用iframe打开URL Scheme，避免直接跳转导致页面卡死
	const iframe = document.createElement('iframe');
	iframe.style.display = 'none';
	iframe.src = url;
	document.body.appendChild(iframe);
	setTimeout(() => {
		document.body.removeChild(iframe);
	}, 1000);


	// 定时器检测是否唤起成功，如果失败则跳转到网页版地图
	let timer = setTimeout(() => {
		window.location.href =
			`https://uri.amap.com/marker?position=${longitude},${latitude}&name=${encodeURIComponent(name)}&src=mypage&coordinate=gaode&callnative=0`; // 默认跳转高德网页版
	}, 2000);

	window.addEventListener('blur', () => {
		clearTimeout(timer)
	});

}


// openMap(116.404, 39.915, "目的地", "baidu");